
CREATE TABLE IF NOT EXISTS "sessions" (
    "sid" varchar NOT NULL COLLATE "default",
    "sess" json NOT NULL,
    "expire" timestamp(6) NOT NULL
) WITH (OIDS=FALSE);
ALTER TABLE "sessions" ADD CONSTRAINT "session_pkey" PRIMARY KEY ("sid") NOT DEFERRABLE INITIALLY IMMEDIATE;

CREATE TABLE IF NOT EXISTS "number" (
    "id" SERIAL PRIMARY KEY NOT NULL,
    "number" varchar NOT NULL UNIQUE COLLATE "default",
    "password" varchar NOT NULL COLLATE "default",
    "number_sid" varchar NOT NULL COLLATE "default",
    "user_id" integer REFERENCES users,
    "token" varchar NOT NULL COLLATE "default",
    "push_id" varchar NOT NULL COLLATE "default"  
) WITH (OIDS=FALSE);

CREATE TABLE IF NOT EXISTS "users" (
    "id" SERIAL PRIMARY KEY NOT NULL ,
    "login" varchar NOT NULL UNIQUE COLLATE "default",
    "pass" varchar NOT NULL COLLATE "default",
    "app_id" varchar COLLATE "default"
) WITH (OIDS=FALSE);