window.onload=function(){
    var tmpl={
        _tmpl:{
            my_number:
			"<input type='text' value='{{number}}' />"+
			"<input type='text' value='{{password}}' /><br/><button class='use_number half_size_button' data-number='{{number}}'>Use</button>"+
			"<button class='release_number half_size_button' data-number='{{number}}'>Release</button><br/>",
            rent_number:"{{number}} <button class='rent_number' data-number='{{number}}'>Rent</button><br/>"
        },
        render:function(name,data,not_escape){
            var html= tmpl._tmpl[name];
            if(!html){
                console.warn(name+' tmpl not found!');
                return JSON.stringify(data);//render жеж. хоть что-то вернем
            }
            var t=html.split('{{');
            html=t.shift();
            t.forEach(function(dt){
                dt=dt.split('}}');
                var prop=dt.shift();
                if(data[prop]){
                    html+=not_escape?data[prop]:data[prop].toString()
                        .replace(/&/g, "&amp;")
                        .replace(/</g, "&lt;")
                        .replace(/>/g, "&gt;")
                        .replace(/"/g, "&quot;")
                        .replace(/'/g, "&#039;");
                }else{
                    console.warn(prop+' not found in input data for tmpl '+name);
                }
                html+=dt.join('}}');
            });
            return html;
        }
	},
	loader=document.getElementById('loader'),
	err_timer, call_counter = 0, call_counter_interval,
	answer=document.querySelector('.call_answer'),
	hangup=document.querySelector('.call_hangup');
	ui={
		error:function(text){
			if(typeof text=='object')//text=JSON.stringify(text);
			{
			     switch(text.status){
		  		case "MIC_ACCESS_PROBLEM": 
				case "MIC_CAM_ACCESS_PROBLEM":
		  			text = "Microphone is not found."; break;
				case "WRONG_SIPPROVIDER_ADDRESS":
		  			text = "WRONG_SIPPROVIDER_ADDRESS"; break;				
				case "REST_AUTHORIZATION_FAIL":
		  			text = "Rest authorization is failed."; break;				
				case "SIP_PORTS_BUSY":
		  			text = "SIP port is busy"; break;				
				case "AUTHENTICATION_FAIL":
		  			text = "Authentification is failed"; break;				
				case "INTERNAL_SIP_ERROR":
		  			text = "Internal error"; break;				
				case "CONNECTION_ERROR":
		  			text = "Got connection error"; break;				
				case "USER_NOT_AVAILABLE":
		  			text = "User not available"; break;				
				case "LICENSE_RESTRICTION":
		  			text = "Your license is restricted"; break;				
				case "LICENSE_NOT_FOUND":
		  			text = "Your license not found"; break;				
				case "REGISTER_EXPIRE":
		  			text = "SIP register is expired"; break;				
				case "MEDIA_PORTS_BUSY":
		  			text = "Media port is busy"; break;				
				case "CALLEE_NAME_IS_NULL":
		  			text = "Caller name is null"; break;				
				case "WRONG_FLASHPHONER_XML":
		  			text = "WRONG_FLASHPHONER_XML"; break;				
				case "PAYMENT_REQUIRED":
		  			text = "PAYMENT_REQUIRED"; break;				
				case "REST_FAIL":
		  			text = "REST_FAIL"; break;				
				break;	
				default: 
					text = "Error code is undefined";			
			     }
			}
			else if(typeof text!='string')text=text.toString();
			document.getElementById('error').style.display='block';
			document.getElementById('error').innerHTML=text;
			if(err_timer)clearTimeout(err_timer);
			err_timer=setTimeout(function(){
				document.getElementById('error').style.display='none';
			},6000);
		},
		login:function(){
			document.getElementById('login_form').style.display='none';
			document.getElementById('current_number').value=document.getElementById('login_in').value;

			document.getElementById('logged').style.display='block';
            document.getElementById('logout').style.display='block';
			document.getElementById('buy_number_icon').style.display='block';
			update_numbers_list();
		},
		logout:function(){
			document.getElementById('login_form').style.display='block';

            document.querySelector('.my_numbers').innerHTML='';
			document.getElementById('current_number').value='';

            document.getElementById('logout').style.display='none';
            document.getElementById('buy_number_icon').style.display='none';
			document.getElementById('logged').style.display='none';
		},
		start_counter:function (){
			if(!call_counter_interval) call_counter_interval = setInterval(function () {
				var sec = call_counter % 60;
				var min = (call_counter - sec) / 60;
				document.querySelector('.call_timer').innerHTML = (min < 10 ? '0' + min : min) + ':' + (sec < 10 ? '0' + sec : sec);
				call_counter++;
			}, 1000);
		},
		stop_counter: function () {
			call_counter = 0;
			document.querySelector('.call_timer').innerHTML='00:00';
			clearInterval(call_counter_interval);
			call_counter_interval=false;
		},
		render_numbers: function(){
			var block=document.getElementById('numbers');
			block.style.display=block.style.display=='block'?'none':'block';
			var block=document.getElementById('logged');
			block.style.display=block.style.display=='block'?'none':'block';
			document.getElementById("buy_number_icon").classList.toggle('active');
		}
		, render_available_numbers:function(numbers){
			var html='';
			for(var i in numbers){
				html+=tmpl.render('rent_number',numbers[i]);
			}
			document.querySelector('.available_numbers').innerHTML=html;
			var t=document.querySelectorAll('.rent_number');
			for(var i =0;i<t.length;i++){
				t[i].onclick=function(){
					node_send({
						url:"rent_number",
						data:{
							number:this.getAttribute('data-number')
						}
					},function(err,res){
						console.log(res);
						update_numbers_list();
					});
				}
			}
		}
		, render_my_numbers: function(numbers){
			console.log(numbers);
			var html='';
            for(var i in numbers) html+=tmpl.render('my_number',numbers[i]);
			document.querySelector('.available_numbers').innerHTML='';
			document.querySelector('.my_numbers').innerHTML='';
			document.getElementById('rent_form').style.display='block';
			if(html){
				document.querySelector('.my_numbers').innerHTML=html;

				var release_buttons=document.getElementsByClassName('release_number');
				for(var i=0;i<release_buttons.length;i++){
					release_buttons[i].addEventListener('click',function(){
						node_send({
							url:"release_number",
							data:{
								number:this.getAttribute('data-number')
							}
						},function(res){
							console.log(res);
							update_numbers_list();
						});
					});
				}

				var use_buttons=document.getElementsByClassName('use_number');
				for(var i=0;i<use_buttons.length;i++) use_buttons[i].onclick=function(){
						var number=this.getAttribute('data-number');
						for(var i in numbers){
							if(numbers[i].number==number){
								document.getElementById('current_number').value=number;
								go_apifo(numbers[i]);
								ui.render_numbers();
								return;
							}
						}
					}
			}
		}

		, incoming: function(call){
			console.log('##### incomming');
			document.getElementById('call_to').value=call.caller;
			//document.getElementById('call_to').className+=' disabled';
			answer.className='call_answer active';
			hangup.className='call_hangup active';
		}
		, ready_to_call: function(){
			console.log('##### Ready');
			ui.stop_counter();
			answer.className='call_answer active';
			hangup.className='call_hangup';
			if(Apifo.registered){
				console.log('##### Account has registered');
			} else {
				console.log('##### Account has not registered');
				document.getElementById('current_number').value = 'Incorrect number or password.';
			}
		}
		, bind_call_events: function(){
			hangup.onclick=function(){
				console.log('##### Cancel call');
				if(this.className.indexOf('active')==-1)return false;
				Apifo.cancel();
				ui.stop_counter();
				this.className=this.className.replace('active');
				answer.className+=' active';
			}
			answer.onclick=function(){
				if(this.className.indexOf('active')==-1)return false;
				if(!Apifo.currentCall){
					console.log('##### Outgoing call');
					var number=document.getElementById('call_to').value
					if(!/\+?[\d]{10,15}/.test(number)){
						ui.error('Incorrect calling number');
					}else{
						ui.start_counter();
						answer.className='call_answer';
						hangup.className='call_hangup active';
						Apifo.call(number);
					}
				}else if(Apifo.currentCall.incoming){
					console.log('##### Incoming call');
					answer.className='call_answer';
					ui.start_counter();
					Apifo.answer(Apifo.currentCall);
				}else{
					//Perharps try to call during another call??
					answer.className='call_answer';
					ui.error('Cant call - active call on line');
				}
			}
			/*
			document.querySelector('.switch').addEventListener('click',function(){
				console.log('##### Speaker '+(this.checked?'ON':'OFF'));
				Apifo.mute(this.checked);
			},true); */
		}
		, bind_events: function(){
			var switches=document.getElementsByClassName('switch');
			for(var i=0;i<switches.length;i++){
				switches[i].onclick=function(){
					this.setAttribute('data-switched',this.getAttribute('data-switched')!='true')
				}
			}
			document.getElementById('open_phonebook').onclick=function(){
				this.opened=!this.opened;
				document.getElementById('phonebook').style.display=this.opened?'block':'none';
			};
			var phones=document.getElementsByClassName('phonebook');
			for(var i=0;i<phones.length;i++){
				phones[i].onclick=function(){
					document.getElementById('call_to').value=this.innerHTML;
					document.getElementById('phonebook').style.display='none';
				}
			}

			document.getElementById('buy_number_icon').onclick=ui.render_numbers;
			document.getElementById('get_available_numbers').onclick=function(){
				node_send({
					url:"available_numbers",
					data:{
						type:'sip',
						country_code:'virtual'
					}
				},function(err,numbers){
					if(err) ui.error(err);
					else ui.render_available_numbers(numbers.available_numbers);
				});
			};
			document.getElementById('login').onclick=function(){
				node_send({
					url:"login",
					data:{
						login:document.getElementById('login_in').value,
						pass:document.getElementById('pass_in').value
					}
				},function(err,response){
					if(response.message=='OK'){
						ui.login();
					}else{
						ui.error('Login || password incorrect');
					}
				});
			};
			document.getElementById('logout').onclick=function(){
				loader.style.display='block';
				node_send({url:"logout"},function(err,data){
					if(err) ui.error(err);
					else ui.logout();
				});
			};
		}
	}



	function node_send(input,callback){
		loader.style.display="block";
        if(!input.url){
            err = new Error('URL required!');
            throw err;
        }else{
            input.url="/"+input.url;
        }
        input.data = input.data || {};
        input.method = input.type || input.method || "POST";

		var xhr = new XMLHttpRequest();
		xhr.open(input.method, input.url);
		for(var name in input.headers){
			xhr.setRequestHeader(name, input.headers[name]);
		}
		xhr.setRequestHeader('X_REQUESTED_WITH', 'XmlHTTPRequest');
		if((input.method=="POST" || input.method=="PUT") && (!input.headers || !input.headers['Content-Type'])){
			xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
		}
		var data='';
		if(typeof input.data!='string'){
			for(var name in input.data){
				data+=name+'='+input.data[name]+'&';
			}
		}else{
			data=input.data;
		}
		xhr.send(data);
		xhr.onerror=function(){
            console.log(xhr.responseText || 'error');
            if(xhr.status==401)ui.logout();
            callback(xhr.responseText);
            loader.style.display='none';
		}
		xhr.onload=function(res){
			try{
				var response=JSON.parse(xhr.responseText);
			}catch(e){
				console.error(e);
				console.log(input);
				console.log(xhr.status);
				console.log(xhr.responseText);
				var response=xhr.responseText;
			}
            callback(null,response);
            loader.style.display='none';
		}
    }
    function update_numbers_list(){
        node_send({
            url:"my_numbers"
        },function(err,numbers){
			if(err)ui.error(err);
			else{
				ui.render_my_numbers(numbers);
				for(var i in numbers) password_timeout(numbers[i]);
			}
        });
    }
	function password_timeout(number){
        setTimeout(function(number){
            console.warn(number.number,'Token expired! Update password..')
            node_send({
                url:"update_pass",
                data:{
                    number:number.number
                }
            },function(err,resp){
                if(!err && resp.number==number.number){
                    //console.log('Updated!',resp);
                    number.password=resp.password;
                    number.expire=resp.expire;
                    var buts=document.getElementsByClassName('use_number');
                    for(var i=0;i<buts.length;i++) if(buts[i] .getAttribute('data-number')==number.number) buts[i].onclick=function(){
                        document.getElementById('current_number').value=number.number;
                        go_apifo(number);
                        ui.render_numbers();
                    };
                    password_timeout(number);
                }else console.error(err||resp);
            });
        },number.expire*1000-Date.now()-7000,number);
    }
	function go_apifo(number){
		Apifo.onerror=function(error){

			ui.error(error);
			ui.ready_to_call();
			console.error(error);
		}
		Apifo.onready=Apifo.onfinish=function(){
			ui.ready_to_call();
			ui.bind_call_events();
		}
		Apifo.incoming=ui.incoming;

		var t=(number.password.split('.'));
		if(t.length==3){
			try{
				number.password=JSON.parse(atob(t[1])).sip_password;
			}catch(e){
                console.error(e);
				//Ok..
			}
		}
		Apifo.init(number.number, number.password);
	}
	window.go_apifo = go_apifo;

	//Init
	loader.style.display='none';
	if(window.authenticated_user) ui.login();
	ui.bind_events();
}
