﻿TERMS OF SERVICE

Last Updated: april 23, 2015

In order to use the APIFONICA API (the “APIFONICA API” or “API”), access the information contained on the www.apifonica.com. website (the “Website”) or make use of the services provided by APIFONICA (the “Service” or “Services” or “Apifonica”), You (hereinafter referred to as “You”, “Your” or “Yourself”) must first read this agreement (the “Terms of Service” or “Agreement”) and accept it.

By using the Website or using the API or Services, You represent that You have read and agree to the terms and conditions of this Agreement, which also include and incorporate Apifonica’s Acceptable Use Policy and Privacy Policy. IF YOU DO NOT AGREE TO THESE TERMS OF SERVICE, EXIT THIS PAGE AND DO NOT ACCESS OR USE THE WEBSITE OR THE APIFONICA API.

These Terms of Service will remain in effect throughout Your use of the Services and continue after this Agreement expires, cancels or is terminated. These Terms of Service are legally binding should You choose to register for the Service. When You create Your APIFONICA account, You must provide us with accurate and complete information. You may not use the API or Services and may not accept the Terms of Service if (a) You are not of legal age to form a binding contract with us, or (b) You are a person barred from receiving the Services under the laws of the Republic of Finland or other countries including the country in which You are a resident or from which You use the Services.

By accepting these terms You acknowledge and agree that You have reached the legal age to enter into such binding Agreement in the country in which You are located or resident or that You have Your parent or legal guardian’s permission if required by applicable law. It is Your responsibility to ensure that You are legally allowed to enter into this Agreement and that You do not violate any applicable laws.

The terms and conditions set forth herein may be amended in our sole and absolute discretion from time to time, and such amended terms and conditions shall be effective immediately upon posting to the Website. Your continued use of the Service after such posting will constitute acceptance by You of such amendments. It is Your responsibility to review these Terms of Service frequently and remain informed about any changes to them, so we encourage You to visit this page often.

1. Grant of Rights to Use Services

1.1 Subject to Your acceptance of and compliance with this Agreement and with the payment requirements for the Services, APIFONICA hereby grants You a limited, non-exclusive, non-transferable, revocable, non-sublicenseable right and license, in and under our intellectual property rights, to access and use the Services, solely in accordance with the terms and conditions of this Agreement. Unless explicitly stated otherwise, any new features provided by APIFONICA that augment or enhance the current Services shall also constitute “Services” and shall be subject to these terms and conditions. You may not, nor allow any third party to, copy, distribute, sell, disclose, lend, transfer, convey, modify, decompile, disassemble or reverse engineer the Services for any purpose whatsoever. You may not allow any unauthorized third party to access the Services for any purpose whatsoever. All rights not expressly granted under this Agreement are retained by APIFONICA.

1.2 You may write a software application or website (an “Application”) that interfaces with the Services. You acknowledge that we may change, deprecate or republish APIs for any Service or feature of a Service from time to time, and that it is Your responsibility to ensure that calls or requests You make to or via our Service are compatible with then-current APIs for the Service. APIFONICA will attempt to inform You of any changes with reasonable notice so You can adjust Your Application, but we are under no obligation to do so.

1.3 You and any Applications that You may build, distribute, or otherwise create may make network calls or requests to the Services, or may receive phone calls via the Service, at any time that the Services are available provided that those requests do not violate the terms of the Acceptable Use Policy or other terms of this Agreement.

1.4 You may not remove, obscure, or alter any notice of any APIFONICA trademark, service mark or other intellectual property or proprietary right appearing on the Website or contained within the Services.

1.5 Provided that You comply with the terms of this Agreement and our policies and procedures including the Acceptable Use Policy and Privacy Policy, You may use the Services to execute Applications owned or lawfully obtained by You. You are solely responsible for Your Applications, including any data, text, images or content contained therein.

1.6 You are personally responsible for all traffic originating from Your Applications using Your account credentials to the Services. As such, You should protect Your authentication keys and security credentials. Actions taken using Your credentials shall be deemed to be actions taken by You, with all consequences including service termination, civil and criminal penalties.

1.7 We may make available to You, for Your installation, copying and/or use in connection with the Services, from time to time, a variety of software, data and other content and printed and electronic documentation (the “APIFONICA Properties”). Subject to Your acceptance of this Agreement, ongoing compliance with its terms and conditions with respect to the subject Service, and payment if and as required for Your right to use the subject Service, we hereby grant to You, without the right to sublicense, a limited, non-exclusive, non-transferable license during the Term of this Agreement (as defined in Section 2.1), under our intellectual property or proprietary rights in the APIFONICA Properties, only to install, copy and use the APIFONICA Properties solely in connection with and as necessary for Your use of such Services and solely to the extent in compliance with all the terms and conditions of this Agreement.

(a) The APIFONICA Properties may include, without limitation:

The APIFONICA Website;
APIFONICA APIs;
Specifications describing the operational and functional capabilities, use limitations, technical and engineering requirements, and testing and performance criteria relevant to the proper use of a Service and its related APIs and technology;
(b) APIFONICA may make available under another license agreement, such as an open source agreement, additional content or software. Any such content or software will be clearly marked with such a license indicating the usage rights available for that content or software. For such content or software released pursuant to an open license, APIFONICA encourages You to modify, alter, tamper with, repair and/or create derivative works consistent with such license. Such content or software may include:

Developer tools, such as software development kits (SDK) or sample code, for use in connection with the APIs;
Articles and documentation for use in connection with the use and implementation of the APIs (collectively, “Documentation”);     
(c) Except as may be expressly authorized under this Agreement:

You may not, and may not attempt to, modify, alter, tamper with, repair, or otherwise create derivative works of any software included in the APIFONICA Properties.
You may not, and may not attempt to, reverse engineer, disassemble, or decompile the APIFONICA Properties or the Services or apply any other process or procedure to derive the source code of any software included in the APIFONICA Properties.
1.8 For purposes of this Agreement, APIFONICA hereby grants to You a non-transferable, non-sublicenseable, non-exclusive license during the Term of this Agreement to display the trade names, trademarks, service marks, logos, domain names of APIFONICA (each, a “APIFONICA Mark”) for the purpose of promoting or advertising that You use the Service. In return You hereby grant APIFONICA a non-transferable, non-sublicenseable, non-exclusive license during the Term of this Agreement to display Your trade names, trademarks, service marks, logos, domain names and the like for the purpose of promoting or advertising that You use the Service. In using APIFONICA Marks, You may not: (i) display a APIFONICA Mark in any manner that implies a relationship or affiliation with, sponsorship, or endorsement by Apifonica; (ii) use Apifonica’s Marks to disparage APIFONICA or its products or services; or (iii) display a APIFONICA Mark on a site that violates any law or regulation. Notwithstanding the above, APIFONICA may determine in its sole discretion whether its marks may be used in connection with Your Application. Furthermore, we may modify any APIFONICA Marks provided to You at any time, and upon notice, You will use only the modified APIFONICA Marks and not the old APIFONICA Marks. Other than as specified in this Agreement, You may not use any APIFONICA Mark unless You obtain our prior written consent.

1.9 The rights granted by us in this Agreement with respect to the APIFONICA Properties, the APIFONICA Marks and the Services are non-exclusive, and we reserve the right to appoint third parties as developers or systems integrators who may offer products or services which compete with Your Application.

2. Term, Termination and Suspension

2.1 The term (“Term”) of this Agreement will commence once You accept this Agreement as provided above. The Agreement will remain in effect until terminated by You or us in accordance with this Section 2.

2.2 You may terminate this Agreement for any reason or no reason at all, at Your convenience. To recover the funds on your account, please contact our support team at support@apifonica.com.

2.3 We may suspend Your right and license to use any or all Services or terminate this Agreement in its entirety (and, accordingly, cease providing all Services to You), for any reason or for no reason, at our discretion at any time by providing You up to thirty (30) days’ advance notice in accordance with the notice provisions set forth in Section 9 below.

2.4 We may suspend Your right and license to use the Service or terminate this Agreement in its entirety (and, accordingly, Your right to use the Service), for cause effective as set forth below:

2.4.1 Immediately upon our notice to You in accordance with the notice provisions set forth in Section 9 below if (i) You violate any provision of the Acceptable Use Policy or Privacy Policy or we have reason to believe that You have violated the Acceptable Use Policy or Privacy Policy, (ii) there is an unusual spike or increase in Your use of the Services for which there is reason to believe such traffic or use is fraudulent or negatively impacting the operating capability of the Service; (iii) we determine, in our sole discretion, that our provision of any of the Services to You is prohibited by applicable law, or has become impractical or unfeasible for any legal or regulatory reason; or (iv) subject to applicable law, upon Your liquidation, commencement of dissolution proceedings, disposal of Your assets, failure to continue Your business, assignment for the benefit of creditors, or if You become the subject of a voluntary or involuntary bankruptcy or similar proceeding.

2.4.2 Immediately and without notice if You are in default of any payment obligation with respect to any of the Services or if any payment mechanism You have provided to us is invalid or charges are refused for such payment mechanism.

2.4.3 Five (5) days following our provision of notice to You in accordance with the notice provisions set forth in Section 9 below if You breach any other provision of this Agreement and fail, as determined by us, in our sole discretion, to cure such breach within such 5-day period.

2.5 Effect of Suspension or Termination.

2.5.1 Upon our suspension of Your use of any Services, in whole or in part, for any reason: (i) fees will continue to accrue for any Services that are still in use by You, notwithstanding the suspension; (ii) You remain liable for all fees, charges and any other obligations You have incurred through the date of suspension with respect to the Services; and (iii) all of Your rights with respect to the Services shall be terminated during the period of the suspension.

2.5.2 Upon termination of this Agreement for any reason: (i) You remain liable for all fees, charges and any other obligations You have incurred through the date of termination with respect to the Services; and (ii) all of Your rights under this Agreement shall immediately terminate.

2.6 In the event this Agreement is terminated for any reason, Sections 5, 6, 7 and 8 will survive any such termination.

2.7 Following the suspension or termination of Your right to use the Services by us or by You for any reason other than a termination for cause, You shall be entitled to take advantage of any post-termination assistance we may generally elect to make available with respect to the Services such as data retrieval arrangements. We may also endeavor to provide You with unique post-suspension or post-termination assistance, but we shall be under no obligation to do so. Your right to take advantage of any such assistance, whether generally made available with respect to the Services or made available uniquely to You, shall be conditioned upon Your acceptance of and compliance with any fees and terms we specify for such assistance.

3. Downtime and Service Suspensions; Security

3.1 The Services are provided on a best-efforts basis. In addition to our rights to terminate or suspend Services to You as described in Section 2 above, You acknowledge that: (i) Your access to and use of the Services may be suspended for the duration of any unanticipated or unscheduled downtime or unavailability of any portion or all of the Services for any reason, including as a result of power outages, system failures or other interruptions; and (ii) we shall also be entitled, without any liability to You, to suspend access to any portion or all of the Services at any time, on a Service-wide basis: (a) for scheduled downtime to permit us to conduct maintenance or make modifications to any Service; (b) in the event of a denial of service attack or other attack on the Service or other event that we determine, in our sole discretion, may create a risk to the applicable Service, to You or to any of our other customers if the Service were not suspended; or (c) in the event that we determine that any Service is prohibited by law or we otherwise determine that it is necessary or prudent to do so for legal or regulatory reasons (collectively, “Service Suspensions”). Without limitation to Section 6, we shall have no liability whatsoever for any damage, liabilities, losses (including any loss of data or profits) or any other consequences that You may incur as a result of any Service Suspension. To the extent we are able, we will endeavor to provide You notice of any Service Suspension in accordance with the notice provisions set forth in Section 9 below and to post updates regarding resumption of Services following any such suspension, but shall have no liability for the manner in which we may do so or if we fail to do so.

3.2 We strive to keep information you provide to us secure, but cannot guarantee that we will be successful at doing so. Accordingly, without limitation to Section 6 below, You acknowledge that You bear sole responsibility for adequate security, protection and backup of Your content including all audio recordings associated with Your account. We strongly encourage You, where available and appropriate, to use encryption technology to protect Your content from unauthorized access and to routinely archive Your content. We will have no liability to You for any unauthorized access or use, corruption, deletion, destruction or loss of any of Your content.

4. Fees

4.1 In its sole discretion, APIFONICA shall determine whether You are eligible for a free trial subscription to its Services, which terms of the free trial are set forth at www.apifonica.com. Free trials are limited to one per person, and if we find that You have created multiple free trial accounts, we reserve the right to suspend those accounts and take actions to prevent additional violations.

4.2 If You have subscribed to the full version of our Services, then You agree to pay applicable fees (including any minimum subscription fees) as set forth at www.apifonica.com/pricing. All payments of fees for the use of our Services will be pre-paid and are non-refundable. Access to the full version of our Services will not be made available until APIFONICA receives payment of fees from You. If You elect to use our Service again in the future You will be required to prepay applicable fees before access to our Services will be made available for Your use. We may increase or add new fees for any existing Service or feature by giving You 30 days’ advance notice. Call and Message Rates are based on variable market pricing and may therefore be subject to change from month to month without prior written notice. All fees payable by You are exclusive of applicable taxes and duties, including, without limitation, VAT and applicable sales tax. You will provide such information to us as reasonably required to determine whether we are obligated to collect any taxes from You.

4.3 We may specify the manner in which You will pay any fees, and any such payment shall be subject to our general accounts receivable policies from time to time in effect. All amounts payable by You under this Agreement will be made without setoff or counterclaim and without deduction or withholding. If any deduction or withholding is required by applicable law, You shall notify us and shall pay such additional amounts to us as necessary to ensure that the net amount that we receive, after such deduction and withholding, equals the amount we would have received if no such deduction or withholding had been required. Additionally, You shall provide us with documentation that the withholding and deducted amounts have been paid to the relevant taxing authority.

4.4 Should You have any dispute as to fees associated with your account, please contact us at support@apifonica.com within 30 days of the date of the activity that generated such dispute, and we will attempt to resolve the matter. Any and all refunds issued to resolve such a dispute shall be issued as credits to Your account, but in no event shall there be any cash refunds. Disputes older than 30 days shall not be entitled to any refunds or credits.

5. Intellectual Property

5.1 Other than the limited use and access rights and licenses expressly set forth in this Agreement, we reserve all right, title and interest (including all intellectual property and proprietary rights) in and to: (i) the Services; (ii) the APIFONICA Properties; (iii) the APIFONICA Marks; and (iv) any other technology and software that we provide or use to provide the Services and the APIFONICA Properties. You do not, by virtue of this Agreement or otherwise, acquire any ownership interest or rights in the Services, the APIFONICA Properties, the APIFONICA Marks, or such other technology and software, except for the limited use and access rights described in this Agreement.

5.2 APIFONICA may, at its discretion, offer certain Software Development Kits, tools, application samples, or documentation under an open source license. Any such products will be marked with copyright details, and those copyrights will apply to those and only those documents. APIFONICA reserves all rights to any documents, tools, services, technologies and the like not designated with an open license.

5.3 Other than the rights and interests expressly set forth in this Agreement and excluding any and all works derived from APIFONICA Properties, You reserve all right, title and interest (including all intellectual property and proprietary rights) in and to: (i) content and data You may send to us or use as part of Your use of any Services (“Your Content”); and (ii) Your Applications.

5.4 In the event You elect, in connection with any of the Services, to communicate to us suggestions for improvements to the Services, the APIFONICA Properties or the APIFONICA Marks (collectively, “Feedback”), we shall own all right, title, and interest in and to the same, even if You have designated the Feedback as confidential, and we shall be entitled to use the Feedback without restriction. Furthermore, any other content or information You post or provide to APIFONICA via comments, forums, emails and the like (collectively, “Communications”) shall be considered the property of APIFONICA. You hereby irrevocably assign all right, title and interest in and to the Feedback and Communications to us and agree to provide us such assistance as we may require to document, perfect, and maintain our rights to the Feedback and Communications.

5.5 During and after the Term of the Agreement, with respect to any of the Services that You elect to use, You will not assert, nor will You authorize, assist, or encourage any third party to assert, against us or any of our customers, end users, vendors, business partners (including third party sellers on websites operated by or on behalf of us), sublicensees or transferees, any patent infringement or other intellectual property infringement claim with respect to such Services.

6. Representations and Warranties; Disclaimers; Limitations of Liability

6.1 You represent and warrant that You will not use the Website (including our forums and comments sections), Services, APIFONICA Properties, APIFONICA Marks, Your Application or Your Content in a manner that violates the Acceptable Use Policy or Privacy Policy. To this effect, we ask that You take reasonable precautions to promote best practices. Although APIFONICA does not assume the duty or obligation to monitor any materials created, posted or uploaded by You or any third parties, APIFONICA reserves the right, in its sole and absolute discretion, to monitor any and all materials posted or uploaded by You or any third parties at any time without prior notice to ensure that they conform to any usage guidelines or policies (including our Acceptable Use Policy and Privacy Policy) relating to our Website or Services.

6.2 You also acknowledge and understand that we do NOT currently allow You to access any 112, 911 or similar emergency services (no traditional 112, 911, or similar access to emergency services). The Services are not intended to replace any primary phone service, such as a traditional landline or mobile phone that may be used to contact emergency services.

6.3You represent and warrant: (i) that You are solely responsible for the development, operation, and maintenance of Your Application and for Your Content, including without limitation, the accuracy, appropriateness and completeness of Your Content and all product-related materials and descriptions; (ii) that You have the necessary rights and licenses, consents, permissions, waivers and releases to use and display Your Application and Your Content; (iii) that neither Your Application nor Your Content (a) violates, misappropriates or infringes any rights of us or any third party, (b) constitutes defamation, invasion of privacy or publicity, or otherwise violates any rights of any third party, or (c) is designed for use in any illegal activity or promotes illegal activities, including, without limitation, in a manner that might be libelous or defamatory or otherwise malicious, illegal or harmful to any person or entity, or discriminatory based on race, sex, religion, nationality, disability, sexual orientation, or age; (iv) that neither Your Application nor Your Content contains any harmful components; and (v) to the extent to which You use any of the APIFONICA Marks, that You will conduct Your business in a professional manner and in a way that reflects favorably on the goodwill and reputation of APIFONICA. You also represent and warrant that You are responsible for any charges incurred by virtue of Your use of the Application, no matter whether the Application acted in error.

6.4 You further agree that You understand that You may use any phone number (including any previously-provisioned direct inward toll-free numbers or vanity numbers) assigned or ported in to Your account and APIFONICA shall not interfere with Your right to port that number away so long as Your account is in good standing and that You provide appropriate supporting documentation in accordance with common industry standards for porting such number away from Apifonica; provided, however, that if Your account has closed, suspended or lapsed for any other reason (including termination of this Agreement) and You have not reactivated Your account or rectified such status within thirty (30) days after the earliest to occur of such event, then at the end of such thirty (30)-day period APIFONICA will immediately assume ownership of any phone numbers and reserves the right to give any of those numbers to other customers, and Your portability rights will be lost. During such thirty (30)-day period, You shall retain the exclusive right to port phone numbers associated with Your account away from APIFONICA.

6.5 You represent and warrant that you have read and understood the Acceptable Use Policy, and Privacy Policy and You agree to abide by their terms, where applicable, including as incorporated by reference herein. You further agree to abide by all applicable local, state, national, foreign and international laws and regulations and that You will be solely responsible for all acts or omissions that occur under Your account or password, including the content of Your transmissions through the Service. By way of example, and not as a limitation, You agree not to violate any provisions of the Acceptable Use Policy and Privacy Policy.

6.6 You represent and warrant that without Apifonica’s express written consent You will not use, and will not authorize any third party to use, any Public Software (as defined below) in connection with the Services in any manner that requires, pursuant to the license applicable to such Public Software, that any APIFONICA Properties or Services be (a) disclosed or distributed in source code form, (b) made available free of charge to recipients, or (c) modifiable without restriction by recipients. With respect to any Feedback or Communications, You represent and warrant that such Feedback and Communications, in whole or in part, contributed by or through You, (i) is legally distributable by You, either because You own the copyright or because You have fully complied with any copyright terms associated with the software or content, (ii) contains no third party software or any software that may be considered Public Software and (iii) does not violate, misappropriate or infringe any intellectual property rights of any third party. “Public Software” means any software, documentation or other material that contains, or is derived (in whole or in part) from, any software, documentation or other material that is distributed as free software, open source software (e.g., Linux) or similar licensing or distribution models, including, but not limited to software, documentation or other material licensed or distributed under any of the following licenses or distribution models, or licenses or distribution models similar to any of the following: (i) GNU’s General Public License (GPL), Lesser/Library GPL (LGPL), or Free Documentation License, (ii) The Artistic License (e.g., PERL), (iii) the Mozilla Public License, (iv) the Netscape Public License, (v) the Sun Community Source License (SCSL), (vi) the Sun Industry Standards License (SISL), (vii) the BSD License and (viii) the Apache License.

6.7 You represent and warrant that: (i) the information You provide in connection with Your registration for the Services is accurate and complete; (ii) You are duly authorized to do business in the jurisdiction where You operate; and (iii) You are an authorized representative of Your entity duly authorized to access the Services and to legally bind You to this Agreement and all transactions conducted under Your account.

6.8 APIFONICA PROPERTIES, THE APIFONICA MARKS, THE SERVICES AND ALL TECHNOLOGY, SOFTWARE, FUNCTIONS, CONTENT, IMAGES, MATERIALS AND OTHER DATA OR INFORMATION PROVIDED BY US OR OUR LICENSORS IN CONNECTION THEREWITH (COLLECTIVELY THE “SERVICE OFFERINGS”) ARE PROVIDED “AS IS.” WE AND OUR LICENSORS MAKE NO REPRESENTATIONS OR WARRANTIES OF ANY KIND, WHETHER EXPRESS, IMPLIED, STATUTORY OR OTHERWISE WITH RESPECT TO THE SERVICE OFFERINGS. EXCEPT TO THE EXTENT PROHIBITED BY APPLICABLE LAW, WE AND OUR LICENSORS DISCLAIM ALL WARRANTIES, INCLUDING, WITHOUT LIMITATION, ANY IMPLIED WARRANTIES OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT, QUIET ENJOYMENT, AND ANY WARRANTIES ARISING OUT OF ANY COURSE OF DEALING OR USAGE OF TRADE. WE AND OUR LICENSORS DO NOT WARRANT THAT THE SERVICE OFFERINGS WILL FUNCTION AS DESCRIBED, WILL BE UNINTERRUPTED OR ERROR FREE, OR FREE OF HARMFUL COMPONENTS, OR THAT THE DATA YOU STORE WITHIN THE SERVICE OFFERINGS WILL BE SECURE OR NOT OTHERWISE LOST OR DAMAGED. WE AND OUR LICENSORS SHALL NOT BE RESPONSIBLE FOR ANY SERVICE INTERRUPTIONS, INCLUDING, WITHOUT LIMITATION, POWER OUTAGES, SYSTEM FAILURES OR OTHER INTERRUPTIONS. NO ADVICE OR INFORMATION OBTAINED BY YOU FROM FINLAND OR FROM ANY THIRD PARTY OR THROUGH THE SERVICES SHALL CREATE ANY WARRANTY NOT EXPRESSLY STATED IN THIS AGREEMENT.

6.9 In addition to the foregoing, we specifically disclaim all liability, and You shall be solely responsible for the development, operation, and maintenance of Your Application and for all materials that appear on or within Your Application and You agree that You shall, without limitation, be solely responsible for:

6.9.1 the technical operation of Your Application and all related equipment;

6.9.2 the accuracy and appropriateness of any materials posted on or within Your Application (including, among other things, any product-related materials);

6.9.3 ensuring that any materials posted on Your site or within Your Application do not violate our Acceptable Use Policy, are not illegal and do not promote illegal activities, including without limitation any activities that might be libelous or defamatory or otherwise malicious, illegal or harmful to any person or entity, or discriminatory based on race, sex, religion, nationality, disability, sexual orientation, or age;

6.9.4 ensuring that Your Application accurately and adequately discloses, either through a privacy policy or otherwise, how You collect, use, store, and disclose data collected from visitors, including, where applicable, that third parties (including advertisers) may serve content and/or advertisements and collect information directly from visitors and may place or recognize cookies on visitors’ browsers; and

6.9.5 any of Your users’ or customers’ claims relating to Your Application or any Services utilized in connection with Your Application.

6.10 NEITHER WE NOR ANY OF OUR LICENSORS SHALL BE LIABLE TO YOU FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, CONSEQUENTIAL OR EXEMPLARY DAMAGES, INCLUDING, BUT NOT LIMITED TO, DAMAGES FOR LOSS OF PROFITS, GOODWILL, USE, DATA OR OTHER LOSSES (EVEN IF WE HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES) IN CONNECTION WITH THIS AGREEMENT, INCLUDING, WITHOUT LIMITATION, ANY SUCH DAMAGES RESULTING FROM: (i) THE USE OR THE INABILITY TO USE THE SERVICES; (ii) THE COST OF PROCUREMENT OF SUBSTITUTE GOODS AND SERVICES; OR (iii) UNAUTHORIZED ACCESS TO OR ALTERATION OF YOUR CONTENT. IN ANY CASE, OUR AGGREGATE LIABILITY UNDER THIS AGREEMENT SHALL BE LIMITED TO THE AMOUNT ACTUALLY PAID BY YOU TO US HEREUNDER FOR THE SERVICES DURING THE PRECEDING TWELVE (12) MONTHS. SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF CERTAIN WARRANTIES OR THE LIMITATION OR EXCLUSION OF LIABILITY FOR INCIDENTAL OR CONSEQUENTIAL DAMAGES. ACCORDINGLY, SOME OR ALL OF THE ABOVE EXCLUSIONS OR LIMITATIONS MAY NOT APPLY TO YOU, AND YOU MAY HAVE ADDITIONAL RIGHTS.

6.11 THE PRODUCTS DO NOT AND ARE NOT INTENDED TO SUPPORT OR CARRY EMERGENCY CALLS TO ANY EMERGENCY SERVICES. “EMERGENCY SERVICES SHALL MEAN SERVICES THAT ALLOW A USER TO CONNECT WITH EMERGENCY SERVICES PERSONNEL OR PUBLIC SAFETY ANSWERING POINTS SUCH AS 112, 911 OR E911 SERVICES.” NEITHER APIFONICA NOR ITS OFFICERS, EMPLOYEES OR AFFILIATES MAY BE HELD LIABLE WHETHER IN CONTRACT, WARRANTY, TORT (INCLUDING NEGLIGENCE), OR ANY OTHER FORM OF LIABILITY FOR ANY CLAIM, DAMAGE, OR LOSS (AND YOU HEREBY WAIVE ANY AND ALL SUCH CLAIMS OR CAUSES OF ACTION), ARISING FROM OR RELATING TO YOUR INABILITY TO USE APIFONICA OR ITS SERVICES TO CONTACT ANY EMERGENCY SERVICES, OR YOUR FAILURE TO MAKE ADDITIONAL ARRANGEMENTS TO ACCESS EMERGENCY SERVICES.

7. Indemnification

7.1 You agree to indemnify, defend and hold us, our affiliates and licensors, each of our and their business partners (including third party sellers on websites operated by or on behalf of us) and each of our and their respective employees, officers, directors and representatives, harmless from and against any and all claims, losses, damages, liabilities, judgments, penalties, fines, costs and expenses (including reasonable attorneys fees), arising out of or in connection with any claim arising out of (i) Your use of the Services, APIFONICA Properties and/or APIFONICA Marks in a manner not authorized by this Agreement, and/or in violation of the applicable restrictions, the Acceptable Use Policy, and/or applicable law, (ii) Your Application, Your Content, or the combination of either with other applications, content or processes, including but not limited to any claim involving infringement or misappropriation of third-party rights and/or the use, development, design, manufacture, production, advertising, promotion and/or marketing of Your Application and/or Your Content, (iii) Your violation of any term or condition of this Agreement or any applicable additional policies, including without limitation, Your representations and warranties, or (iv) You or Your employees’ or personnel’s negligence or willful misconduct.

7.2 We agree to promptly notify You of any claim subject to indemnification; provided that our failure to promptly notify You shall not affect Your obligations hereunder except to the extent that our failure to promptly notify You delays or prejudices Your ability to defend the claim. At our option, You will have the right to defend against any such claim with counsel of Your own choosing (subject to our written consent) and to settle such claim as You deem appropriate, provided that You shall not enter into any settlement without our prior written consent and provided that we may, at any time, elect to take over control of the defense and settlement of the claim.

8. Disputes

8.1 Notwithstanding anything to the contrary, we may seek injunctive or other relief in any state, federal, or national court of competent jurisdiction for any actual or alleged infringement of Apifonica’s or any third party’s intellectual property and/or proprietary rights. Any dispute hereunder shall be adjudicated in Finland, and You consent to exclusive jurisdiction and venue in such courts. You further acknowledge that our rights in the APIFONICA Properties and the APIFONICA Marks are of a special, unique, extraordinary character, giving them peculiar value, the loss of which cannot be readily estimated and may not be adequately compensated for in monetary damages.

8.2 By using the Services, You agree that the laws of the Republic of Finland, without regard to principles of conflicts of laws, will govern this Agreement and any dispute of any sort that might arise between You and us.

9. Notices

9.1 Notices made by us under this Agreement for You or Your account specifically (e.g., notices of breach and/or suspension) will be provided to You via a notification message displayed on your account page or via the email address provided to us in Your registration for the Services or in any updated email address You provide to us in accordance with standard account information update procedures we may provide from time to time. It is Your responsibility to keep Your email address current and You will be deemed to have received any email sent to any such email address, upon our sending of the email, whether or not You actually receive the email.

9.2 For notices made by You to us under this Agreement and for questions regarding this Agreement or the Services, You may contact APIFONICA as follows: support@apifonica.com.

10. Miscellaneous Provisions

10.1 Responsibility. If You authorize, assist, encourage or facilitate another person or entity to take any action related to the subject matter of this Agreement, You shall be deemed to have taken the action Yourself.

10.2 Severability. If any portion of this Agreement is held by a court of competent jurisdiction to be invalid or unenforceable, the remaining portions of this Agreement will remain in full force and effect, and any invalid or unenforceable portions shall be construed in a manner that most closely reflects the effect and intent of the original language. If such construction is not possible, the provision will be severed from this Agreement, and the rest of the Agreement shall remain in full force and effect.

10.3 Waivers. The failure by us to enforce any provision of this Agreement shall in no way be construed to be a present or future waiver of such provision nor in any way affect our right to enforce such provision thereafter. All waivers by us must be in writing to be effective.

10.4    Successors and Assigns. This Agreement will be binding upon, and inure to the benefit of the parties and their respective successors and assigns.

10.5 Entire Agreement. This Agreement incorporates by reference all policies and guidelines posted on the APIFONICA Website and as may be modified thereafter (including the Acceptable Use Policy and the Privacy Policy) and constitutes the entire agreement between You and us regarding the subject matter hereof and supersedes any and all prior or contemporaneous representation, understanding, agreement, or communication between You and us, whether written or oral, regarding such subject matter.

10.6 No Endorsement. You understand and acknowledge that we are not certifying nor endorsing, and have no obligation to certify or endorse, any of Your Applications or Your Content.

Email:  support@apifonica.com

Multiregional TransitTelecom Oy

Fredrikinkatu 55, 5th floor. 00100 Helsinki
Phone: +358 9 31-57-51-61

