**********************************************************************
Apifonica Web SDK for server platforms (Version 2.2.4).
======================================================================
(c) Copyright 2017 MTT Oy. 
**********************************************************************

About
-------------------
This Web SDK provides an easy way to use Apifonica service with REST APIs, to rent numbers, to create XML, and do other common server-side programming tasks. 
The Web SDK consists of two parts: the server-side path and the WebPhone demo project.  
The server-side path of Web SDK uses for monitoring and connection between Mobile (iOS/Android), WebPhone devices and Apifonica service. 
The WebPhone demo project contains functions to rent phone number, make VoIP phone calls in the customer web browser.

Requirements
-------------------
* npm installation
* Node.js
* MySQL or PostgreSQL

Features for server-side
-------------------
* Server management and its interaction with Mobile SDK apps and Apifonica server;
* Monitoring of the rented phone numbers;
* Monitoring Incomming/OutGoing Calls via XML scenarios;
* Synchronize the rented numbers stored on the your server-side with rented numbers stored in your Apifonica account.

Feature for WebPhone
-------------------
* Rent of phone number;
* Supports incoming/outgoing VoIP calls on the base of WebRTC service;
* Audio connection with audio codecs (OPUS/G722/G711(u/a-law)/SHA-256);
* Supports Google Chrome, Firefox Mozilla, Safari browsers.

Documentation
-------------------
API Reference is included to the docs subdirectory of the SDK and can also be found at
<https://www.apifonica.com>.

More information
-------------------
For the list of new features and known issues, refer to the [release notes](release_notes.md).
ure requests to [support@apifonica.com](mailto:support@apifonica.com).

Support
-------------------
If you have any questions about this SDK, feel free to contact us at [support@apifonica.com](mailto:support@apifonica.com).

