var Apifo2 = require('apifo_v2'),
    schedule = require('node-schedule'),
    self = this;

this.Apifo2 = new Apifo2(config.apifo.sid, config.apifo.token);
this.router = require('./routes/')(this);
this.db = require('./db.js')(this);
this.generate_pass = function () {
    var alph = '0123456789qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM';
    for (var i = 0, pass = ''; i < 16; i++, pass += alph[~~(Math.random() * 62)]);
    return pass + ~~(Math.random() * 10);
};

this.sync = function () {
    console.log(new Date(), 'Update numbers');
    engine.db.get_my_numbers(config.default_user, (err, db_numbers) => {
        console.log(new Date(), 'BD numbers', db_numbers);
        var site_numbers = [], page = 1;
        (function get_numbers_page(cb) {
            engine.Apifo2.get_numbers_list({
                page: page
            }, (err, numbers) => {
                site_numbers = site_numbers.concat(numbers.numbers);
                if (numbers.total > site_numbers.length) {
                    console.log(new Date(), 'Get page', page);
                    get_numbers_page(cb);
                } else cb();
            });
        })(function () {
            //console.log(site_numbers, db_numbers);
            site:for (var i in site_numbers) {
                db:for (var j in db_numbers) {
                    if (site_numbers[i].number == db_numbers[j].number) {
                        db_numbers.splice(j, 1);
                        continue site;
                    }
                }
                //add site number to db...
                console.log('add site number to db', site_numbers[i]);
                var pass = engine.generate_pass();
		console.log('##Try to update number with <Sync> button in engine.js');
                self.Apifo2.update_number({
                    number_sid: site_numbers[i].number_sid,
                    mode: "sip_phone", //"end_point",// "xml",
                    sip_password: pass
                }, function (err, resp) {
                    if (err) {
                        console.log({
                            number_sid: site_numbers[+this.i].number_sid,
                            sip_password: this.pass
                        }, err);
                    }
                    self.db.save_number({
                        token: site_numbers[+this.i].token,
                        number_sid: site_numbers[+this.i].number_sid,
                        number: site_numbers[+this.i].number,
                        password: this.pass,
                        user_id: config.default_user
                    }, function (err, resp) {
                        console.log(resp, 'saved')
                    });
                }.bind({i, pass}));
            }
            console.log(new Date(), 'need delete numbers:', db_numbers.length);
            for (var i in db_numbers) {
                //delete number from db...
                console.log('delete number from db', db_numbers[i]);
                self.db.delete_number({number: db_numbers[i].number}, (err, result) => {
                    if (err) console.error(new Date(), 'delete number failed', db_numbers[i], err);
                });
            }
        });
    });

};

// Synchonize the current list rented numbers with apifonica
// this.main_job = schedule.scheduleJob({hour: 0, minute: 0}, self.sync);

exports = self;
