CREATE DATABASE IF NOT EXISTS websdk_example;

USE websdk_example;

CREATE TABLE IF NOT EXISTS `websdk_sessions` (
    `session_id` VARCHAR(64) NOT NULL PRIMARY KEY,
    `data` LONGTEXT NOT NULL,
    `expires` integer
);

CREATE TABLE IF NOT EXISTS `websdk_number` (
    `id` SERIAL PRIMARY KEY NOT NULL,
    `number` varchar(16) NOT NULL UNIQUE,
    `password` varchar(64) NOT NULL,
    `number_sid` varchar(64) NOT NULL,
    `user_id` integer REFERENCES number ON DELETE SET NULL,
    `token` varchar(128),
    `push_id` varchar(512)
);

CREATE TABLE IF NOT EXISTS `websdk_users` (
    `id` SERIAL PRIMARY KEY NOT NULL ,
    `login` varchar(64) NOT NULL UNIQUE,
    `pass` varchar(64) NOT NULL,
    `app_id` varchar(128)
);

INSERT INTO websdk_users (login,pass,app_id) VALUES ( "login", "password", "e1965a984e1c93e5a46966dfab4192a8");

