var pg = require('pg');
module.exports = function(Engine){
    var self=this;
    function query(input,callback){
        if(typeof input=='string')input={query:input};
        console.log(input.query);
        pg.connect(config.pgsql_connect,function(err,client,done){
            if(err)return callback(err);
            client.query(input.query, input.data||[],function(err,result){
                //console.log(err,result);
                done();
                if(err)return callback(err);
                callback(null,result);
            });
        });
    }
    self.test=function(test_query,callback){
        query(test_query,callback);
    }
    self.get_user_by_login=function(login,callback){
        query("SELECT * FROM users WHERE login='"+login+"'",function(err,res){
            if(err){
                return callback(err);
            }
            callback(err,res.rows[0]||null);
        });
    }
    self.get_user_by_id=function(id,callback){
        query("SELECT * FROM users WHERE id='"+id+"'",function(err,res){
            if(err){
                return callback(err);
            }
            callback(err,res.rows[0]||null);
        });
    }
    self.get_my_numbers=function(id,callback){
        query("SELECT num.number,num.password FROM users as u RIGHT JOIN number as num ON (u.number_id=num.id) WHERE u.id="+id,function(err,res){
            if(err)return callback(err);
            callback(err,res.rows||[]);
        });
    }
    self.save_number=function(input,callback){
		query({
            query:"INSERT INTO number (number,password) VALUES ('"+input.number+"','"+input.password+"') RETURNING id",
            data:{}
        },function(err,res){
            if(err)return callback(err);
            query({
                query:"UPDATE users SET number_id="+res.rows[0].id+" WHERE id="+input.user_id,
                data:{}
            },function(err,res){
                if(err)return callback(err);
                callback(null,'ok');
            });
        });
    }
	self.delete_number=function(input,callback){
		query({
            query:"DELETE FROM number WHERE number='"+input.number+"'",
            data:{}
        },function(err,res){
            if(err)return callback(err);
            query({
                query:"UPDATE users SET number_id=NULL WHERE id="+input.user_id,
                data:{}
            },function(err,res){
                if(err)return callback(err);
                callback(null,'ok');
            });
        });
    }

    return self;
};